<template>
  <div class="header-container">
  <!-- <div class="header-empty-space" v-if="isSideNavOpen"></div> -->
  <div class="header" :class="{'header-fixed': isSideNavOpen, 'header-menu-open': isSideNavOpen}">
    <nuxt-link to="/">
      <img src="~/assets/images/header/thorchain-logo-community-driven.svg" alt="Thorchain org " />
    </nuxt-link>
    <!-- <transition name="current-route"> -->
      <div v-if="!isSideNavOpen" class="current-route">
          {{currentRoute}}
      </div>
    <!-- </transition> -->
    <!-- <transition name="block-counter"> -->

      <ext-link v-if="isSideNavOpen" class="no-style">
        <div class="nav-rune" :class="{ 'nav-rune-new-block': newBlock }">
          <div class="nav-rune-logo">
            <img
              src="~/assets/images/icons/nav-block-height-rune-symbol.svg"
              alt=""
            />
          </div>
          <div
            class="nav-rune-number"
            :class="{ 'nav-rune-number-new-block': newBlock }"
          >
            {{ blockHeight }}
          </div>
        </div>
      </ext-link>
    <!-- </transition> -->
  </div>
  </div>
</template>

<script>
import utils from '../../../utils'
import ExtLink from "../../../components/main/ExtLink"
export default {
  components: {
    ExtLink
  },
  data(){
    return {
      blockHeight: "CONNECTING",
      newBlock: false,
      currentRoute: this.routeObjToRouteName(this.$route)
    }
  },
  computed: {
    isSideNavOpen() {
      return this.$store.getters["nav/toggleSidebar"];
    },
  },
  mounted(){
    var self = this
    self.updateLastBlock()
    setInterval(async ()=>{
      await self.updateLastBlock()
    }, 2000)
  },
  methods: {
    async updateLastBlock(){
      var lastBlock = await this.$services.getLastBlock()
        var lastBlock = utils.numberWithCommas(lastBlock)
      if(lastBlock && lastBlock != this.blockHeight){
        this.blockHeight = lastBlock
        this.newBlock = true
        var self = this
        setTimeout(()=>{self.newBlock = false}, 1000)
      }
    },
    routeObjToRouteName($route){
      function capitalizeFirstLetter(string) {
        return string.charAt(0).toUpperCase() + string.slice(1);
      }
      var routeName = ""
      if($route.path != "/")
        /* Remove slash and uppercase the first letter */
        var routeName = capitalizeFirstLetter($route.path.split('/')[1])
        if(routeName=="Rune") routeName = "RUNE"

      return routeName
    }
  },
  watch:{
    $route(to, from) {
      this.currentRoute = this.routeObjToRouteName(this.$route)
    }
  }
};
</script>

<style lang="scss">
.header {
  background-color: #000b12;
  height:  2.875rem;
  border-bottom: 0.0625rem solid #15252e;
  display: flex;
  justify-content: space-between;
  align-items: center;
  padding-left: 1.25rem ;
  padding-right: 1.25rem ;
  width: 100%;
  &.header-menu-open{
    border-bottom: 0.0625rem solid transparent;
    z-index: 100;
  }
  img {
    height: 1.75rem ;
  }

  &.header-fixed{
    position: fixed;
    top:0;
  }
}
.header-empty-space{
  height:  2.875rem;
}
.nav-rune-container {
  cursor: pointer;

  .no-style {
    text-decoration: none;
  }
}
.nav-rune {
  display: flex;
  // padding: 0.125rem 0.0625rem 0.0825rem 0.0625rem ;
  height: 1rem ;
  width: 6.875rem;
  border-radius: 0.125rem;
  margin-top: 0rem;
  background-color: white;
  transition: 0.5s ease;

  &:hover {
    background-color: #23dcc8;
    transition: 0.1s ease;
    .nav-rune-number {
      color: #23dcc8;
      border-color: #23dcc8;
    }
  }

  .nav-rune-logo {
    padding: 0rem 0.3rem;
    display: flex;
    img {
      margin-top: -0.35rem;
      width: 0.5rem;
      margin-left: 0.1rem;
    }
  }

  .nav-rune-number {
    border: 0.1rem solid #fff;
    border-left: none;
    border-radius: 0 0.1875rem 0.1875rem 0;
    font-family: "Roboto Mono", Roboto, monospace;
    font-weight: 300;
    text-align: center;
    font-size: 0.6rem;
    color: #fff;
    flex-grow: 3;
    background-color: #000;
    transition: color 0.5s ease;
    line-height: 0.75rem;
  }
  .nav-rune-number-new-block {
    color: #20cab8;
    border-color: #23dcc8;

    transition: color 0s ease;
  }
}
.nav-rune-new-block {
  background-color: #20cab8;
  transition: 0s ease;
}
.current-route {
  font-family: Roboto;
  font-style: normal;
  font-weight: bold;
  font-size: 1rem;
  line-height: 1.1rem;
  /* identical to box height */
  text-align: right;
  color: #23DCC8;
  position: absolute;
  right: 1.3rem;
}
.block-counter-enter-active,
.block-counter-leave-active {
  transition: all 0.3s ease-out;
}
.block-counter-enter,
.block-counter-leave-to {
  transform: translateX(100%);
}

.current-route-enter-active,
.current-route-leave-active {
  transition: all 0.3s ease-out;
}
.current-route-enter,
.current-route-leave-to {
    opacity: 100%;

}
</style>
